﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace Benday.EfCore.Api.Migrations
{
	public partial class PersonLastUpdated : Migration
	{
		protected override void Up(MigrationBuilder migrationBuilder)
		{
			migrationBuilder.AddColumn<DateTime>(
				name: "LastUpdated",
				table: "Person",
				nullable: false,
				defaultValueSql: "CONVERT(date, '1/1/1900')");

			migrationBuilder.Sql(GetSqlForCreateLastUpdatedTrigger());
		}
		private string GetSqlForCreateLastUpdatedTrigger()
		{
			string sql = @"
CREATE TRIGGER [dbo].[Person_Create_LastUpdated_OnInsertUpdate] ON [dbo].[Person]
	AFTER INSERT, UPDATE
AS
BEGIN
	SET NOCOUNT ON;
				  
	IF ((SELECT TRIGGER_NESTLEVEL()) > 1) RETURN;
	
	DECLARE @Id INT
		
	SELECT @Id = INSERTED.Id
	FROM INSERTED
		  
	UPDATE dbo.Person
	SET LastUpdated = GETDATE()
	WHERE Id = @Id
END
";

			return sql;
		}

		protected override void Down(MigrationBuilder migrationBuilder)
		{
			migrationBuilder.DropColumn(
				name: "LastUpdated",
				table: "Person");
		}
	}
}
