﻿using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Benday.EfCore.Api;

namespace Benday.EfCore.Api.Migrations
{
    [DbContext(typeof(MyDbContext))]
    partial class MyDbContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
            modelBuilder
                .HasAnnotation("ProductVersion", "1.1.1")
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("Benday.EfCore.Api.Media", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("MediaType")
                        .IsRequired();

                    b.Property<DateTime>("PublicationDate");

                    b.Property<string>("Title");

                    b.HasKey("Id");

                    b.ToTable("Media");

                    b.HasDiscriminator<string>("MediaType").HasValue("Media");
                });

            modelBuilder.Entity("Benday.EfCore.Api.Person", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("FirstName");

                    b.Property<string>("LastName");

                    b.Property<DateTime>("LastUpdated")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasDefaultValueSql("CONVERT(date, '1/1/1900')");

                    b.HasKey("Id");

                    b.ToTable("Person");
                });

            modelBuilder.Entity("Benday.EfCore.Api.Phone", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<int>("OwnerId");

                    b.Property<string>("PhoneDescription")
                        .IsRequired();

                    b.Property<string>("PhoneNumber")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("OwnerId");

                    b.ToTable("PersonPhone");
                });

            modelBuilder.Entity("Benday.EfCore.Api.Book", b =>
                {
                    b.HasBaseType("Benday.EfCore.Api.Media");

                    b.Property<string>("Author");

                    b.Property<int>("PageCount");

                    b.Property<string>("Summary");

                    b.ToTable("Book");

                    b.HasDiscriminator().HasValue("Book");
                });

            modelBuilder.Entity("Benday.EfCore.Api.Movie", b =>
                {
                    b.HasBaseType("Benday.EfCore.Api.Media");

                    b.Property<int>("LengthInMinutes");

                    b.ToTable("Movie");

                    b.HasDiscriminator().HasValue("Movie");
                });

            modelBuilder.Entity("Benday.EfCore.Api.MusicAlbum", b =>
                {
                    b.HasBaseType("Benday.EfCore.Api.Media");

                    b.Property<string>("Artist");

                    b.Property<int>("NumberOfTracks");

                    b.ToTable("MusicAlbum");

                    b.HasDiscriminator().HasValue("Music Album");
                });

            modelBuilder.Entity("Benday.EfCore.Api.Phone", b =>
                {
                    b.HasOne("Benday.EfCore.Api.Person", "Owner")
                        .WithMany("PhoneNumbers")
                        .HasForeignKey("OwnerId")
                        .HasConstraintName("FK_Phone_Person")
                        .OnDelete(DeleteBehavior.Cascade);
                });
        }
    }
}
